<template>
  <div
    class="w-full flex items-center px-1 py-2 border-b border-[#767680] border-opacity-100 sticky top-[64px] bg-white z-[5] bg-surface"
    :class="[
      type === TopBarLearnModuleTypes.show ? 'justify-between' : 'justify-end',
    ]"
  >
    <!-- Go back button -->
    <svn-pro-icon-button
      v-if="type === TopBarLearnModuleTypes.show"
      variant="text"
      color="onSurfaceVariant"
      icon="custom:mingcute:arrow-left-line"
      @click="emit('close-and-go-back')"
    />

    <div class="w-fit h-full flex items-center self-end">
      <!-- Edit button -->
      <svn-pro-icon-button
        v-if="creatorOrAdmin && type === TopBarLearnModuleTypes.show"
        variant="text"
        color="onSurfaceVariant"
        icon="custom:mingcute:edit-2-line"
        @click="emit('edit-module')"
      />

      <!-- AI module button -->
      <svn-pro-icon-button
        v-if="
          type === TopBarLearnModuleTypes.draft ||
          type === TopBarLearnModuleTypes.edit
        "
        variant="text"
        :color="isAiConversationOpen ? 'primary' : 'onSurfaceVariant'"
        :icon="isAiConversationOpen ? 'custom:mingcute:sparkles-2-fill' : 'custom:mingcute:sparkles-2-line'"
        @click="emit('toggle-ai-conversation')"
      />

      <!-- Preview module button -->
      <svn-pro-icon-button
        v-if="
          type === TopBarLearnModuleTypes.draft ||
          type === TopBarLearnModuleTypes.edit
        "
        variant="text"
        color="onSurfaceVariant"
        icon="custom:mingcute:eye-2-line"
        @click="emit('preview-module')"
      />

      <!-- Module options button -->
      <svn-pro-menu
        v-if="
          type === TopBarLearnModuleTypes.draft ||
          type === TopBarLearnModuleTypes.edit
        "
        :items="menuItems"
      >
        <template #activator="{ props }">
          <svn-pro-icon-button
            v-bind="props"
            variant="text"
            color="onSurfaceVariant"
            icon="custom:mingcute:more-2-line"
          />
        </template>
      </svn-pro-menu>

      <!-- Update module button -->
      <svn-pro-button
        v-if="
          saveMode === TopBarLearnModuleSaveTypes.manual &&
          type === TopBarLearnModuleTypes.edit
        "
        variant="flat"
        :text="updateText"
        @click="emit('save-module')"
      />

      <div
        v-if="type === TopBarLearnModuleTypes.draft"
        class="flex items-center gap-2"
      >
        <!-- Publish module button -->
        <svn-pro-button
          v-if="saveMode === TopBarLearnModuleSaveTypes.manual"
          variant="text"
          :text="saveText"
          @click="emit('save-module')"
        />

        <!-- Publish module button -->
        <svn-pro-button
          variant="flat"
          :text="publishText"
          @click="emit('publish-module')"
        />
      </div>

      <!-- Comments button -->
      <svn-pro-icon-button
        v-if="type === TopBarLearnModuleTypes.show"
        variant="text"
        color="onSurfaceVariant"
        icon="custom:mingcute:chat-4-line"
        @click="emit('toggle-comments')"
      />

      <!-- Favorite button -->
      <svn-pro-icon-button
        v-if="type === TopBarLearnModuleTypes.show"
        variant="text"
        :color="isFavorited ? 'primary' : 'onSurfaceVariant'"
        :icon="
          isFavorited
            ? 'custom:mingcute:heart-fill'
            : 'custom:mingcute:heart-line'
        "
        @click="emit('toggle-favorite')"
      />

      <!-- Copy link button -->
      <svn-pro-icon-button
        v-if="type === TopBarLearnModuleTypes.show"
        variant="text"
        color="onSurfaceVariant"
        icon="custom:mingcute:link-line"
        @click="emit('copy-link')"
      />

      <!-- Download PDF -->
      <svn-pro-icon-button
        v-if="type === TopBarLearnModuleTypes.face_to_face"
        variant="text"
        color="onSurfaceVariant"
        icon="custom:mingcute:download-2-line"
        @click="emit('download-pdf')"
      />

      <!-- Close and Go back button -->
      <svn-pro-icon-button
        v-if="type !== TopBarLearnModuleTypes.show"
        variant="text"
        color="onSurfaceVariant"
        icon="custom:mingcute:close-line"
        @click="emit('close-and-go-back')"
      />
    </div>
  </div>
</template>

<script setup>
import {
  TopBarLearnModuleTypes,
  TopBarLearnModuleSaveTypes,
} from "../../constants/types.js";
import SvnProMenu from "../../components/menu/SvnProMenu.vue";
import SvnProButton from "../../components/button/SvnProButton.vue";
import SvnProIconButton from "../../components/button/SvnProIconButton.vue";

const props = defineProps({
  type: { type: String, default: "view" },
  saveMode: { type: String, default: "auto" },
  saveText: { type: String, default: "Save" },
  menuItems: { type: Array, default: () => [] },
  isFavorited: { type: Boolean, default: false },
  updateText: { type: String, default: "Update" },
  publishText: { type: String, default: "Publish" },
  creatorOrAdmin: { type: Boolean, default: false },
  isAiConversationOpen: { type: Boolean, default: false },
});

const emit = defineEmits([
  'toggle-comments',
  'toggle-favorite',
  'copy-link',
  'edit-module',
  'toggle-ai-conversation',
  'save-module',
  'preview-module',
  'close-and-go-back',
  'publish-module',
  'download-pdf',
  ]);
</script>
